#ifndef DWUNITSHH
#define DWUNITSHH

#define DWpi            3.1415926535897932384626433832795028841971693993751
#define DWtwoPi         6.2831853071795864769252867665590057683943387987502

// At time of writing (7/1/2000) parameters are stored internally
// in the units corresponding to whichever of the units below have
// scaling of unity (1.0).
// Of course, the user does not need to know this, as he or she will
// define output and input of his or her parameters through these macros.

#define DWm             1000.0
#define DWcm            10.0
#define DWmm            1.0
#define DWradian        (180.0/DWpi)
#define DWdegree        1.0

#define DWpercent       0.01
#define DWfraction      1.0
#define DWdimensionless 1.0
#endif
