#ifndef AGDDUSERGEOMETRYHH
#define AGDDUSERGEOMETRYHH

#include "preXmlManager.hh"
#include "agddBuildable.hh"

namespace agdd {

  class UserGeometry {
    typedef struct {
      preXml::Manager * preXmlManager;
    } InputStructure;
    typedef struct {
      agdd::Buildable * theBuildable;
    } OutputStructure;
  private:
    InputStructure _in;
  public:
      UserGeometry(InputStructure & in) : 
	  _in(in) {
      };
  public:
    // The user must implement the following member to
    // to idefine his or her geometry.
    // The user may use the contents of _in if so desired.
    OutputStructure defineUserGeometry();
  }; 

}; // end of agdd namespace

#endif
