
#include <vector>
#include "agddSection.hh"
#include "agddVolume.hh"
#include "ExpatInterface/Element.h"

namespace agdd {

  Volume::Volume() : _amInserted(false), _sec(0) {};
  bool Volume::thisVolumeIsAssignedToASection() const { // In the sense of section elements.
    return _sec?true:false;
  };
  bool Volume::thisVolumeIsInSomeSection() const { // In the sense of section elements.
    return _amInserted;
  };
  void Volume::doVolumeThingsToThisElement(xml::Element * elt) {
    nameThisElement(elt);
  };
  void Volume::setSectionForThisVolume(agdd::Section * sec) {
    assert(!thisVolumeIsAssignedToASection());
    assert(sec);
    _sec=sec;
  };

  // A shorthand:
  void Volume::putThisVolumeElementIntoThisSection(xml::Element * elt, agdd::Section * sec) {
    setSectionForThisVolume(sec);
    putTheFollowingVolumeElementIntoItsSection(elt);
  };

  void Volume::putTheFollowingVolumeElementIntoItsSection(xml::Element * elt) {
    //assert(sec);
    assert(elt);
    assert(thisVolumeIsNotInSomeSection());
    _sec->theElement()->addChild(elt);
    //_sec=sec;
    _amInserted=true;
  };
  Section * Volume::getSection() {
    assert (thisVolumeIsAssignedToASection());
    return _sec;
  };
} // end of agdd namespace




