#ifndef AGDDVOLUMEHH
#define AGDDVOLUMEHH

#include <vector>
#include "agddHasName.hh"
#include "agddSection.hh"
#include "ExpatInterface/Element.h"

namespace agdd {

  class Volume : public HasName {
  private:
    bool _amInserted;
    Section * _sec; // Section I have been or will be inserted into (as an xml element).
  public:
    Volume();
    virtual void putMyselfIn(Section *) = 0;
    virtual ~Volume() {};
  protected:
    void doVolumeThingsToThisElement(xml::Element * elt) ;
    bool thisVolumeIsAssignedToASection() const ;
    inline bool thisVolumeIsNotAssignedToASection() const { return !thisVolumeIsAssignedToASection(); } ;
    bool thisVolumeIsInSomeSection() const ;
    inline bool thisVolumeIsNotInSomeSection() const { return !thisVolumeIsInSomeSection(); } ;
  protected: // public:
    void setSectionForThisVolume(agdd::Section * sec);
    void putThisVolumeElementIntoThisSection(xml::Element * elt, agdd::Section * sec);
    void putTheFollowingVolumeElementIntoItsSection(xml::Element * elt /*, agdd::Section * sec */ ) ;
  protected:
    Section * getSection() ;
  };

} // end of agdd namespace

#endif



